tigase.xmpp.impl

## Class JabberIqVersion

- java.lang.Object
- - tigase.xmpp.XMPPProcessor
  - - tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor
    - - tigase.xmpp.XMPPProcessorAbstract
      - - tigase.xmpp.impl.JabberIqVersion

- All Implemented Interfaces:
    Comparable<XMPPImplIfc>, XMPPImplIfc, XMPPProcessorIfc

      public class JabberIqVersion
      extends XMPPProcessorAbstract

  XEP-0092: Software Version Created: Tue Mar 21 06:45:51 2006
  Version:
    $Rev$
  Author:
    Artur Hefczyc

- - ### Field Summary

    - ### Fields inherited from class tigase.xmpp.XMPPProcessor

      `ALL_NAMES, ALL_PATHS, cmpInfo`

    - ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

      `CLIENT_XMLNS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JabberIqVersion()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `id()` Method `id` returns a unique ID of the plugin.
    `void` | `processFromUserOutPacket(JID connectionId, Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)` The method is called when a packet is sent from the user, owner of the session somewhere else to other XMPP entity (other user on the server, other user on a different server, different server, component, transport, etc....).
    `void` | `processFromUserPacket(JID connectionId, Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)` The method is called for all packets sent by the user, owner of this connection/session.
    `void` | `processFromUserToServerPacket(JID connectionId, Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)` The method is called when a packet is send from the user who is owner of the session to the local server (ping, roster management, privacy lists, etc...).
    `void` | `processServerSessionPacket(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)` The method is called when a packet addressed to the server domain is received.
    `Element[]` | `supDiscoFeatures(XMPPResourceConnection session)` Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request.
    `String[][]` | `supElementNamePaths()` Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin.
    `String[]` | `supNamespaces()` Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin.

    - ### Methods inherited from class tigase.xmpp.XMPPProcessorAbstract

      `process, processNullSessionPacket, processToUserPacket`

    - ### Methods inherited from class tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor

      `supStreamFeatures, supTypes`

    - ### Methods inherited from class tigase.xmpp.XMPPProcessor

      `canHandle, compareTo, concurrentThreadsPerQueue, getComponentInfo, getInstance, getStatistics, init, isSupporting, supElements, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

      `canHandle, concurrentQueuesNo, concurrentThreadsPerQueue, getComponentInfo, getStatistics, init, isSupporting, supElements, supStreamFeatures, supTypes`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

- - ### Constructor Detail

    - #### JabberIqVersion

          public JabberIqVersion()

  - ### Method Detail

    - #### id

          public String id()

      Description copied from interface: `XMPPImplIfc`
      Method `id` returns a unique ID of the plugin. Each plugin has own, unique ID which is used in the configuration file to determine whether it needs to be loaded or not. In most cases the ID can be equal to XMLNS of the packages processed by the plugin.
      Specified by:
        `id` in interface `XMPPImplIfc`
      Overrides:
        `id` in class `AnnotatedXMPPProcessor`
      Returns:
        a `String` value

    - #### processFromUserPacket

          public void processFromUserPacket(JID connectionId,
                                            Packet packet,
                                            XMPPResourceConnection session,
                                            NonAuthUserRepository repo,
                                            Queue<Packet> results,
                                            Map<String,Object> settings)
                                     throws PacketErrorTypeException

      Description copied from class: `XMPPProcessorAbstract`
      The method is called for all packets sent by the user, owner of this connection/session. Please note, it is likely that a user sends a packet addressed to his own server, like get server version information. In such a case only this method is called. Such a packet is not later passed to the `processServerSessionPacket(...)`. Note, the default implementation checks whether the packet is addressed to the server or is being sent to another XMPP entity. In the first case it calls `processFromUserToServerPacket(...)` method, otherwise it calls `processFromUserOutPacket`. You can overwrite the method to change the default behavior or implement the two called methods to handle each case separately.
      Overrides:
        `processFromUserPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `connectionId` - is a `JID` instance with the session connection ID.
        `packet` - is a `Packet` sent by the user.
        `session` - is a `XMPPResourceConnection` instance with all the sending user session data.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.
      Throws:
        `PacketErrorTypeException` - on attempt to send an error response to the error packet.

    - #### processFromUserOutPacket

          public void processFromUserOutPacket(JID connectionId,
                                               Packet packet,
                                               XMPPResourceConnection session,
                                               NonAuthUserRepository repo,
                                               Queue<Packet> results,
                                               Map<String,Object> settings)

      Description copied from class: `XMPPProcessorAbstract`
      The method is called when a packet is sent from the user, owner of the session somewhere else to other XMPP entity (other user on the server, other user on a different server, different server, component, transport, etc....). The default implementation just forwards the packet doing nothing else, which is good enough in most cases. You can overwrite the method to change the default behaviour.
      Overrides:
        `processFromUserOutPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `connectionId` - is a `JID` instance with the session connection ID.
        `packet` - is a `Packet` sent by the user.
        `session` - is a `XMPPResourceConnection` instance with all the sending user session data.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.

    - #### processFromUserToServerPacket

          public void processFromUserToServerPacket(JID connectionId,
                                                    Packet packet,
                                                    XMPPResourceConnection session,
                                                    NonAuthUserRepository repo,
                                                    Queue<Packet> results,
                                                    Map<String,Object> settings)

      Description copied from class: `XMPPProcessorAbstract`
      The method is called when a packet is send from the user who is owner of the session to the local server (ping, roster management, privacy lists, etc...). There is no default implementation for the method.
      Specified by:
        `processFromUserToServerPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `connectionId` - is a `JID` instance with the session connection ID.
        `packet` - is a `Packet` sent by the user.
        `session` - is a `XMPPResourceConnection` instance with all the sending user session data.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.

    - #### processServerSessionPacket

          public void processServerSessionPacket(Packet packet,
                                                 XMPPResourceConnection session,
                                                 NonAuthUserRepository repo,
                                                 Queue<Packet> results,
                                                 Map<String,Object> settings)

      Description copied from class: `XMPPProcessorAbstract`
      The method is called when a packet addressed to the server domain is received. Please note, if a local user sends a packet to the server, the packet is handled by the `processFromUserPacket(...)` method. This method is not called for such packets.
      Specified by:
        `processServerSessionPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `packet` - is a `Packet` received by the server and addressed to the server - the server virtual domain name.
        `session` - is a `XMPPResourceConnection` instance with all the server session data.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.

    - #### supDiscoFeatures

          public Element[] supDiscoFeatures(XMPPResourceConnection session)

      Description copied from interface: `XMPPImplIfc`
      Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request. Service discovery features returned by this method correspond to services supported by this plugin.
      Specified by:
        `supDiscoFeatures` in interface `XMPPImplIfc`
      Overrides:
        `supDiscoFeatures` in class `AnnotatedXMPPProcessor`
      Parameters:
        `session` - a `XMPPResourceConnection` value
      Returns:
        an `Element[]` value

    - #### supElementNamePaths

          public String[][] supElementNamePaths()

      Description copied from interface: `XMPPImplIfc`
      Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin. Each element name path corresponds to XMLNS returned in array by `supNamespaces()` method. The element path itself is represented by a String array with each path element as a separate String.
      Specified by:
        `supElementNamePaths` in interface `XMPPImplIfc`
      Overrides:
        `supElementNamePaths` in class `AnnotatedXMPPProcessor`
      Returns:
        a `String[][]` value is an array for element paths for which the plugin offers processing capabilities. Each path is in form of a String array in order to reduce parsing overhead.

    - #### supNamespaces

          public String[] supNamespaces()

      Description copied from interface: `XMPPImplIfc`
      Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin. Each namespace corresponds to element name returned in array by `supElemenets()` method.
      Specified by:
        `supNamespaces` in interface `XMPPImplIfc`
      Overrides:
        `supNamespaces` in class `AnnotatedXMPPProcessor`
      Returns:
        a `String[]` value

Copyright © 2022 "Tigase, Inc.". All rights reserved.